﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.ComponentModel;
using Infragistics.Controls;

namespace DataChartZoomBarRangeDisplay
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ChartViewModel vm = new ChartViewModel();
        public MainWindow()
        {
            InitializeComponent();

            DataContext = vm;

            
        }

        private void XamZoombar_ZoomChanging(object sender, Infragistics.Controls.ZoomChangeEventArgs e)
        {
            xMax.ValueChanged -= xMax_ValueChanged;
            xMin.ValueChanged -= xMin_ValueChanged;
            if (Math.Abs(XamZoombar1.Range.Minimum - e.NewRange.Minimum) > .001
                || Math.Abs(XamZoombar1.Range.Maximum - e.NewRange.Maximum) > .001)
            {
                XamZoombar1.Range = e.NewRange;
            }
            vm.AxesProperties.MimimumXDisplayValue = xAxis.ActualMinimumValue + ((xAxis.ActualMaximumValue - xAxis.ActualMinimumValue) * e.NewRange.Minimum);
            vm.AxesProperties.MaximumXDisplayValue = xAxis.ActualMinimumValue + ((xAxis.ActualMaximumValue - xAxis.ActualMinimumValue) * e.NewRange.Maximum);            
            xMax.ValueChanged += xMax_ValueChanged;
            xMin.ValueChanged += xMin_ValueChanged;

        }

        void VerticalZoombar_ZoomChanging(object sender, ZoomChangeEventArgs e)
        {
 
            
            yMax.ValueChanged -= yMax_ValueChanged;
            yMin.ValueChanged -= yMin_ValueChanged;

            vm.AxesProperties.MaximumYDisplayValue = yAxis.ActualMaximumValue - ((yAxis.ActualMaximumValue - yAxis.ActualMinimumValue) * e.NewRange.Minimum);
            vm.AxesProperties.MimimumYDisplayValue = yAxis.ActualMaximumValue - ((yAxis.ActualMaximumValue - yAxis.ActualMinimumValue) * e.NewRange.Maximum);  
            
            yMax.ValueChanged += yMax_ValueChanged;
            yMin.ValueChanged += yMin_ValueChanged;
        }

        private void xamDataChart1_Loaded(object sender, RoutedEventArgs e)
        {
            xMax.ValueChanged += xMax_ValueChanged;
            xMin.ValueChanged += xMin_ValueChanged;
            xamDataChart1.VerticalZoombar.ZoomChanging += VerticalZoombar_ZoomChanging;
            yMax.ValueChanged += yMax_ValueChanged;
            yMin.ValueChanged += yMin_ValueChanged;
        }


        #region Y Axis Display Range
        void yMin_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue != null)
            {
                xamDataChart1.VerticalZoombar.ZoomChanging -= VerticalZoombar_ZoomChanging;
                double max =
                    (yAxis.ActualMaximumValue - (double)e.NewValue)
                    / (yAxis.ActualMaximumValue - yAxis.ActualMinimumValue);

                if (Math.Abs(max - xamDataChart1.VerticalZoombar.Range.Maximum) > .001)
                {
                    xamDataChart1.VerticalZoombar.Range = new Range
                    {
                        Minimum = xamDataChart1.VerticalZoombar.Range.Minimum,
                        Maximum = max
                    };
                }

                xamDataChart1.VerticalZoombar.ZoomChanging += VerticalZoombar_ZoomChanging;
            }
        }

        void yMax_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue != null)
            {
                xamDataChart1.VerticalZoombar.ZoomChanging -= VerticalZoombar_ZoomChanging;
                double min =
                    (yAxis.ActualMaximumValue - (double)e.NewValue)
                    / (yAxis.ActualMaximumValue - yAxis.ActualMinimumValue);

                if (Math.Abs(min - xamDataChart1.VerticalZoombar.Range.Minimum) > .001)
                {
                    xamDataChart1.VerticalZoombar.Range = new Range
                    {
                        Minimum = min,
                        Maximum = xamDataChart1.VerticalZoombar.Range.Maximum
                    };
                }

                xamDataChart1.VerticalZoombar.ZoomChanging += VerticalZoombar_ZoomChanging;
            }
        }
        #endregion

        #region X Axis Display Range
        private void xMax_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue != null)
            {
                XamZoombar1.ZoomChanging -= XamZoombar_ZoomChanging;
                double max =
                    ((double)e.NewValue - xAxis.ActualMinimumValue)
                    / (xAxis.ActualMaximumValue - xAxis.ActualMinimumValue);
                if (max >= 1)
                {
                    XamZoombar1.Range = new Range
                    {
                        Minimum = XamZoombar1.Range.Minimum,
                        Maximum = 1
                    };
                }

                if (Math.Abs(max - XamZoombar1.Range.Maximum) > .001)
                {
                    XamZoombar1.Range = new Range
                    {
                        Minimum = XamZoombar1.Range.Minimum,
                        Maximum = max
                    };
                }
                XamZoombar1.ZoomChanging += XamZoombar_ZoomChanging;
            }
        }

        private void xMin_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue != null)
            {
                XamZoombar1.ZoomChanging -= XamZoombar_ZoomChanging;
                double min = ((double)e.NewValue - xAxis.ActualMinimumValue)
                    / (xAxis.ActualMaximumValue - xAxis.ActualMinimumValue); ;
                if (Math.Abs(min - XamZoombar1.Range.Minimum) > .001)
                {
                    XamZoombar1.Range = new Range
                    {
                        Minimum = min,
                        Maximum = XamZoombar1.Range.Maximum
                    };
                }
                XamZoombar1.ZoomChanging += XamZoombar_ZoomChanging;
            }

        }
        #endregion
       


    }




    public class XRangeToValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
   
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }



    public class ChartViewModel : PropertyChangedNotifier
    {
        private ObservableCollection<ChartData> data;
        private AxesProperties props;

        public ChartViewModel()
        {
            Data = ChartData.GenerateData(1001);
            AxesProperties = new AxesProperties
               {
                   MimimumXDisplayValue = 0,//data.Min(d => d.Index),
                   MaximumXDisplayValue = 0//data.Max(d => d.Index),
               };
        }

        public ObservableCollection<ChartData> Data
        {
            get { return data; }
            set { data = value; OnPropertyChagned("Data"); }
        }


        public AxesProperties AxesProperties
        {
            get { return props; }
            set { props = value; OnPropertyChagned("AxesProperties"); }
        }
        
    }

    public class AxesProperties : PropertyChangedNotifier
    {
        private double minXDisplayValue;

        public double MimimumXDisplayValue
        {
            get { return minXDisplayValue; }
            set { minXDisplayValue = value; OnPropertyChagned("MimimumXDisplayValue"); }
        }

        private double maxXDisplayValue;

        public double MaximumXDisplayValue
        {
            get { return maxXDisplayValue; }
            set { maxXDisplayValue = value; OnPropertyChagned("MaximumXDisplayValue"); }
        }

        private double minYDisplayValue;

        public double MimimumYDisplayValue
        {
            get { return minYDisplayValue; }
            set { minYDisplayValue = value;OnPropertyChagned("MimimumYDisplayValue"); }
        }

        private double maxYDisplayValue;

        public double MaximumYDisplayValue
        {
            get { return maxYDisplayValue; }
            set { maxYDisplayValue = value; OnPropertyChagned("MaximumYDisplayValue"); }
        }      
        

    }

    public class ChartData
    {
        public int Index { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Index = 150,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Index = i + 150
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }

    public class PropertyChangedNotifier : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
